                             mcam-1.6.2


Program to grab frames from the 'Creative Labs Video Blaster II' webcam.
This program may also work with other makes that use the Vision Cpia chip.



                  IMPORTANT COPYRIGHT NOTICE README
For mpeg coding use the modified Berkely coder/decoder from my site:
I cannot integrate the Berkely decoder because it is not GPL, and for non
commercial use only.
GPL requires it to be a separate program.
Wish they GPL'd it, then I could integrate it.
Please use mcam with the Berkely coder/decoder for non commercial
purposes only, see the Berkely Makefile.
mcam itself is GPL, but if you use the decoder.... :)
SO, again, you CANNOT integrate the Berkely coder/decoder or any modification
of it in mcam, as mcam has to stay GPL.
It is forbidden to remove this notice from the code. 

Latest version of the mpeg coder / decoder is on my site:
http:/www.panteltje.demon.nl/mcam/
				_

       * Please also read the bottom of this file for the latest changes, *
       * and what to do if compile problems *
           

Requirements:
Linux as from 1.2.13
X windows as from X11R6 (but compilation without X possible, see below)
Any par port, unidirectional will work.
You must be root (for access to the IO ports).

No kernel upgrades needed.


Making the executable:
Create the Makefile:
xmkmf

Compile for using X:
make

Install the program, (copies executable and icon into the normal directories).
make install
That copies the executable and icon into the normal directories.

Or just simply type:
./make_x

If you want to run a server on a machine without X:
To make a version of mcam that does not use X: 
./make_no_x	

This creates and installs mcam_no_x
This particular version does not display anything.
It is useful as a server on a machine that has no X windows installed,
or to provide .ppm files with handshake for uploap.
--

Running mcam:
There are in fact 2 ways to run mcam:
The recommended way is to:
1)
Start mcam as a server with: mcam -s
Start a second mcam as a client with: mcam -c -a localhost
Then you should get a picture in the client.
Type /help for a list of commands you can give while you watch the picture.
mcam -h shows some command line options

The other way is to use mcam stand alone:
2)
start mcam with: mcam
This brings you in the test menu.
Then select option 4, option 5, option 9
You should now have a picture
If you hit ENTER you are back in the menu. 


Problems and solutions:
Problems with color depth
Sometimes color depth is detected wrong by X.
You can force it, for example if you have 32 bits per pixel, with
menu option 'J', answere 'm' to the question manual / auto, then 
enter 32 as reply to color depth.
This forces 32 bit mode, wingetdepth() sometimes seems to return the
wrong value.

Please read all the way through this document, as for each new version
mentioned, new features and commands were added.
Things may actually have changed!

Yes we need a manual.
If you read all of this, you will in fact be guided through most
new features, in the same sequence I programmed these.


If you want to make a .ppm from a frame:
Hit enter, then X, a filename will be asked for, and the picture is
saved to disk.
If you did not type the extension '.ppm' it will be appended.
The .ppm pictures can be viewed with almost any viewer, for example xv.
You could also:
Stop the picture by typing ctrl Z.
Then in the same xterm type:
import mypicture.gif.
A cross cursor will appear.
click in the picture, wait for the beeps...
and continue grabbing by typing fg.

The import program is part of the imagemagick distribution.

Parallel port addresses:
The default is fixed at LPT1 0x378
If you want to use a different port:

mcam -l 0x278

To start mcam from a window manager (using its own xterm) (push action):
xterm -geometry 80x28 -sb -sl 500 -j -ls -e mcam



I have added simple save routines, the saved format is that used by X.
During display (function 9), if you type 'F' the xbuffer is saved to disk
for each frame as:
frame.0, frame.2 ..... frame.n
Typing 'f' stops the saving.
This uses LOTS of disk space!!!
It is useful for getting the best pic out of something, or to play short
movies.

You can replay a single frame by typing 'l', a number will be asked for.
If you type 'L', all frames will be replayed, a start point and delay
will be asked for.


Added compression, upload now much faster, some artifacts may show.
Compression can be enabled by typing 'E'.
(After you left the grabbing with ENTER).
'e' disables compression.


Using mcam with cuseeme:
There exists a client QSeeMe-0.83b.tar.gz
The URL is: no source however it seems.
http://www.pangea.org/~mavilar/qseeme/qseeme.html

If you enter in the  ~/.qseemerc file:
; mcam
GrabX=0
GrabY=0
GrabWinName=mcam

Start mcam first, make a small picture with 'p'
Optionally enable compress with 'E'
Then start QSeeMe with:
QSeeMe -l ppp0

Then connect...
Your ppp link MUST be up first, or else QSeeMe will exit.
I have nothing to do with QSeeMe, just used it.


You can select the format that frames are saved in is now ppm, or xbuffer.
This allows you to also read these frames with for example xv.

Note that ~/,mcamrc will be automatically generated if you change any
settings.
Only settings you changed are added to this file.
Else the defaults of the webcam will be used.
So setting contrast to 20 will cause an entry to be added to the ~/.mcamrc.
Editing this file is not recommended.

Warning:
If you save frames as .ppm, then function 'L' cannot display your animation.
In that case use:
xv -wait 1 -wloop frame.*.ppm

I have disabled choice 2 in the menu (system test), because it writes to
the EEPROM, and EEPROMs have a limited number of write cycles.

Password now active.
Set server password with menu option 'S', see also below!


The client server model:
If you want to for example see what goes on in your home from an other
location, or perhaps just have a life picture of someone you are IRC ing
with, have one mcam started make sure you got a pic, then select menu
choice 'M'.
 Perhaps set a password first with option 'S', say for example 'hello'.
 ('no' for password assumes no password, this is the default).
 If the password is anything else then 'no' it is not shown.
 You can find it in ~/.mcamrc however.
The text 'ENTER aborts server" will appear.
Now the server is running.
Now start a second mcam like this:
mcam -c -a localhost -p 6668 -w my_secret.

Now after a little while you should have a picture.

The delay between the pictures is determined by the network, the processor
speed of the server, and by the delay set by option 'F' in the menu.
Note that option 'F' also starts the saving of frames to disk.
So you can also save frames from the server machine, that can be anywhere in
the world.
Selecting 'f' from the menu stops the saving, but leaves the delay as is.
If you want no delay, set it to zero.
Settings are saved in the .mcamrc file.


version-0.8.4
Now you can start the server from the command line with:
mcam -s -p 6666
(for example, where 6666 is the port mcam listens on).
(set server password first with menu option 'S'.
A server password of 'no' (the default) allows any password to connect.

And you can start mcam as client (it needs no camera then) with:
mcam -c -p 6666 -a far.away.host -w my_secret
(for port 6666, host far.away.host, password my_secret).


version-0.8.5
You can send text, just type it in the server window.
any text<ENTER> is send to all clients.
You can send text from a client ot the server.
Normally you would run 2 instances of mcam, one a a server, one as a client.
/quit<ENTER> exits the server mode
/stat<ENTER> shows some stats (number connected clients, speed etc.).
/help shows the command you can send to the server (see below for pasword).
Connect messages and password errors are always shown.


version-0.8.6
Most camera remote commands implemented, header larger, restart function,
longer text, but client to server text still has a bug (length limitation)
Just a snapshot for today:)


version-0.8.7
Now you can read (almost) all status from the server with /stat.
There is a second password, set with function 'm') that allows server
control from a specific client.
That means that you, as root, can control the server / camera remotely,
and other clients can (optionally with a password) just see the picture.
Of cause you could give the control password to more then one client etc..

Some simple /help option added.
Bug in text length client to server fixed.
Some documentation header format used can be found in internet.h.


version-0.8.8
Now changing size (/camera small /camera big) in the client pops up a new
window of the correct size.
I cannot get the old window to close it seems, any X experts (closewin() in
x11.c)?
Number of clients in /stat now reported correctly, used offset -17 which was
reporting of fatal error, so that should now work too.


version-0.8.9
Select timeout in server and client set to one second, to reduce CPU cycles.
This is especially important for the server if no connections.

Warning if client attempts to send commands to camera and has no permission.
Warning if syntax error in commands.

Colordepth can be manually set (menu option 'J') in case X returns a wrong
value.

Compensation can be set in menu choice 'R'.

Imakefile added

version-0.9
Compensation gains can be set separately for exposue with menu option 'r'.
More local commands in client mode: frame_delay, start_frame, frame_format.
Improved status display.
Bugfixes.


version-0.9.1
Small step for version number, big step in complexity :)
Added internal calls to the Berkely mpeg2 coder / decoder
Also /camera mpeg on and /camera mpeg off remote commands work.
You need to install the modified Berkely encoder from my site to use
this options.

The mpeg option works only on 352 x 288 (else segfault perhaps).
There are a lot of artifacts, and you need a fast PC, but usefull for
over the net.

This is not a true implementation of mpeg2, due to some limitations in the
Berkely decoder (its a demo after all) it cannot parse bitstreams (I think).
This would cause problems when a clients connect at a random time.
Now I parse frame by frame.

IMPORTANT:
You need to move the file  single.par to the directory you keep your frames
in (set with menu option 'd' if you start mcam without arguments),
I use /root/frames.

How it works:
Coding:
mcam writes the current frame in ppm format to /tmp/mcam-ppm.ppm.
Then it calls (using popen) mpeg2encode, and creates the mpeg2 bitstream
/root/frames/temp.out (or wherever is your frame dir).
temp.out is then read into the DataBuffer + 64 (and send over TCP/IP if in
server mode).

Decoding:
The DataBuffer + 64 contains the mpeg bitstream, in client mode received
over TCP/IP, in stand alone mode by reading the mpeg2 bitstream file
temp.out.

This encoded data is written to /root/frames/ftemp (or wherever you keep your
frames).
Then mcam uses popen to call p2dec (modified version of mpeg2decode), which
creates /root/frames/gstream.gs (or where ever you keep your frames).
This now is the proper cpia format, and gstream.gs is read into the 
DataBuffer + 64, and processing proceeds as normal.
Note:
The format of gstream.gs is basically the cpia picture stream.
(line lenght low, line length high, YUYV..  .YUYV, 0xfd(end of line marker)
An end of frame is signaled by 4 0xff).

Simple is it not? :)

I had to pen this down, just wrote it, will forget it.
Why so complicated?
OK, I had to keep 2 different programs, because of different licences.
Also the coder/decoder does not use stdin, stdout, but files.
Finally the file single.par must be in the right place, it gives the coder
info about the size and filenames / locations, parameters of the input.
Is it slow? No, because all these little files will be cached by Linux.


version-0.9.2:
Forgot to include single.par :( now here it is.


version-0.9.3
Many code modifications:
Basically you can now do *any* combination of:
/camera big / small
/camera compression on / off (compression data camera to par port)
/camera mpeg on / off  (compression data over the net)
Try -e command line flag for verbose messages (a lot)
In compression on data is now accumulated correctly, also in mpeg over the
net.
I have changed the mpeg decoder again, so it also works on a small picture.
Now you have to have the files small.par and big.par in the directory
you keep your frames (set with mcam menu option 'd')
single.par is no longer needed.

Try mcam -s 
Then in an other xterm mcam -c , answere anything for password.
After you get a picture in the client:
/camera small
/camera compression on
/camera mpeg on
Do it on a fast PC, cuseeme? who cares.
We have color, can serve many clients, can remote control, can on line
change picture size, send and receive text messages, password protection,
all that on a 486 for example.
I recommend to get a separate (second?) par port card, especially if you
also have a printer or some other equipment that needs a par port.
Then start mcam with for example mcam -s -l 278 
 

version-0.9.4
FugBixes
Moved one more temp file for mpeg decoding to /tmp/.
Disabled test routine that printed warning messages on startup.

Stable now tested with 3 mcams as client, one as server on localhost,
with mpeg and compression on, big picture, for one hour.
Ready for 1.1? :)


version-0.9.5
BugBixes
Added fclose somewhere, now the server does not die with too many files open
anymore in mpeg.
-This is the first stable release.

To make it possible to get data from mcam into an other application, I have
implemented the folowing:
If you start mcam normally (not as a server, then choose the (new) menu option
'O' (capital) (for output), then mcam will write each frame in the format
mcam.ppm in the frame dir (directory you set with option 'd' from the menu).

After mcam.ppm is written, a file mcam.ppm.ready will be created in the same
directory, and mcam will check every 100 milli seconds to see if this file is
erased.
Then and only then will mcam make a new mcam.ppm, and a new mcam.ppm.ready
semaphore file.

Your script (or program) should wait for mcam.ppm.ready to exist, then read
mcam.ppm, and when it is ready, delete mcam.ppm.ready, to signal to mcam that
it should create a new mcam.ppm

Then your script should wait for mcam.ppm.ready.

so:
label1:
wait for mcam.ppm.ready to exists
process mcam.ppm
delete mcam.ppm.ready
loop label1

Hope this is of some use, I have tested this with true mpeg streaming, this
handshake method works very well.

Also note that mcam will wait indefinatly for mcam.ppm.ready to be deleted,
before it will need the next frame.

I thought that perhaps the advantage of using X is that you can still monitor
the picture that you send to your webpage, even if you browse to some other URL.


(there is no 0.9.6, it was the same as -0.9.5)
version-0.9.7:
You can now also use the -O flag on the command line, both in server, client,
and stand alone mode (note it must be upper case), or select 'O' from the
menu.
Warning messages will appear, as mcam may seem to 'hang' but it is only
waiting for frame_dir/mcam.ppm.ready to be deleted by your aplication.
This to avoid confusion.

version-0.9.8:
Special effects option
Option 'U' from the menu enables color processing.
The file effects.dat in the frame directory (set with menu option 'd')
has some parameters that control the color processing:
example:
y comparator value, u comparator value, v comparator value,
y comparator width, u comparator width, v comparator width,
y replacement value, u replacement value, v replacement value.
40 95 170  10 15 20  254 95 180
U and V are only replaced if BOTH are within the window.

So you basically have a chroma key.
Changing the file (with a text editor (use save to disk, while staying in
the editor) ), is possible while mcam runs, so you can immedialtly see the
result.

To disable a comparator, set its window size to zero.
This all works ONLY with compression OFF.

About the color signals u and v:
These signals present the color component of each pixel.
With these 2 signals, that may each be positive (127 - 255) zero (127) or
negative (0 - 127) any color can be selected.
Think of these as 2 vectors, 90 degrees to each other.
In the middel of a circle.
For amplitude zero of the vectors, the saturation is zero.
The saturation is the vector sum of both the u and v vector.
This vector can point in any of the 4 quadrants, pointing to any color.
The longer the vector sum, the stronger the saturation.
In the color circle described by the resulting (rotating) vector,
blue is top, red is right.
u (blue vector) 255 is blue, 127 is no color, 0 is yellowish
v (red vector) 255 is red, 127 = no color, 0 is greenish

In the color system (last time I looked) the luminance signal 'Y'
is coded as .3 x R + .59 x G + .11 x B.

When you set the u comparator value to say 200, and the u comparator width
to say 10, then an internal flag is set if u is between 195 and 205.

If you set the v comparator value to 100, and the v comparator width to
20, then an other internal flag is set if v is between 90 and 110.

When both flags are set, then u is replaced by u replacement, and v is
replaced by v replacement.

So for example, if you wanted to replace the color red is a frame by green,
with some margin in color allowed:
y comparator value = 0 (not used),
u comparator value = 127 (zero, no u),
v comparator value = 200 (red),

y comparator width = 0 (no effect on y),
u comparator width = 255 (make sure flag is always set),
v comparator width = 50 (allow some tolerance),

y replacement value = 0 (not used),
u replacement value = 0 (greenish),
v replacement value is 127 (no change here).
So:
0 127 200  127 127 30  0 0 127


It is possibble to make very artistic looking pictures using this method.
Try:
100 127 200  20 127 50  255 0 12


version-0.9.9:
Added motion detection.
Enabling motion detection from the menu (option 'V') will affect the picture
save functions.

You can specify paramaters in the file frame_dir/change_parameters.
(Where frame_dir is the directory you set with menu option 'd').
You should copy the file change_parameters to your frame_dir, and
edit only the numbers in it.
Any difference value in that file can be changed from 0 to 255,
the treshhold value can be changed from 0 to several hundred thousand. 

For example you could set the following values:
y_difference=20
This adds 1 to an internal counter for any pixel that differs more then 20
steps in brightness from the previous frame.
u_difference=30
Any u (color vector) that differs more then 30 etc.
v_difference=40 same for v color vector.
treshhold=1000
This is compared to the counter, and if the counter value is higher then
threshhold, the picture is considered changed, and will be saved.
Values are not critical, above values will even work with noise (low light).

Please note that ANY moving thing (like for examples leaves on a tree) will
add to the value treshold is compared against, also changes in light
intensity, like the sun or clouds.
So this would be good for indoor use, with artificial light.

Motion detection can for example be used to monitor a room for intruders,
Then only if someone comes in, or something moves, the changed frames will
be saved to disk (if saving is enabled).


version-0.9.9.1:
Bug fix segfault happend if file change_parameters was not found.


version-0.9.9.2:
Using mcam live on the www:

Two scrips are included that you can use to upload pictures to the ftp server
of your ISP (if they have one).

First start the mcam server:
nice -n 19 xterm -geometry 80x28 -sb -sl 500 -j -ls -e mcam -s

Make sure your frames directory is /root/frames, you need to be root for all
this.

Edit send-live, the upload script, for the server, name, password, and
directory.
Also make sure you have libjpeg on your system, as cjpeg is used to convert
from a ppm to jpg format.

start the upload script:
send-live

The file live.html is an example of a html page that refreshes every minute.
It uses the picture live.jpg.
Edit it as required.

Once the send-live script is running, you can use an other mcam client to
make changes to the camera settings:
mcam -c -w e
Then /help
so for example /camera small will change to a small picture.
then /quit, to avoid using excessive processor cycles.

Making mpg movies
First get mpeg_encode-1.5b-2.src.rpm (it is on www.mpeg.org)
If you do not have rpm get it from somewhere.
Then do rpm --install mpeg_encode-1.5b-2.src.rpm
cd /usr/src/packages/SOURCES
tar -zxvf mpeg_encode-1.5b-src.tar.gz
cd mpeg_encode
make

and install mpeg_encode somewhere (copy to /usr/local/bin/ perhaps)

examples are in directory test.

I have included a mcam.param file for PPM output from mcam.
Put it in the directory where you keep your frames.
Edit this file as required:
The following fields are important:

change this to where you want the .mpg file to go. 
OUTPUT	/root/frames/mcam.mpg

change this to the directory where mcam writes its frame.xx.ppm files
INPUT_DIR       /root/frames/

enter the first and last frame number here.
INPUT
frame.*.ppm     [0-251]
END_INPUT

leave the other fields, especially the BASE_FILE_FORMAT        PPM


Then in the same directory you keep mcam.param, do:
mpeg_encode mcam.param


This will (after some time, encoding is slow), create a .mpg file

A good program to view these files is mpeg_play.

New functions:
Now mcam can use the jpeg library libjpeg.
It is available from sunsite:
ftp sunsite.unc.edu/pub/linux/libs/graphics/libjpeg-6a.tar.gz
Installing it creates the executable files cjpeg and djepg.
Mcam can use cjpeg to code (read compress) images it sends over the net.
And it can use djpeg to decompress at the client side.
To activate the jpeg coding use menu function 'j'.
Or from the client type:
/camera coding jpeg
/camera coding off will switch coding back of again.
/camera coding mpeg will use the modified Berkely codec.
I strongly recommend to use the jpeglib, as it is faster, more universal,
possibly already present on your machine, and free, but read its README.
I have not dropped support for the Berkely codec though, as some people
may want to use it.
The other thing you can now do, when selecting jpeg coding, is set the
quality (menu option 'Q'), for example 20 for a very high compression
(and low quality), or 75 for a very high quality, but large image sizes
(in bytes).
For use over the net this allows you to select the best (or fasted) coding
for the case used.
Note:
 The function ppm_to_gstream() in picture_coder.c could perhaps also be used
 for other things.
 It converts a .ppm file (output from djpeg) to the format (sort of YUYV)
 used by the camera.

If you install libjpeg, you can make a .jpg file from a .ppm like this:
cjpeg -quality nn xxxx.ppm > xxx.jpg


version-1.0:
Two commands have been added for use in the client in client server mode:
/save filename
This saves the current settings (status server and client) in the frames
directory (the one you specified in ~/.mcamrc or via menu option 'j') as
p.filename. p. stands for preset here.

You can edit this file, or make your own, but note that the sequence of
commands may be important, for example start recording after you set the
recording format, set gain_ceiling after you select auto exposure.

/load filename
This loads the file p.filename in the frame directory, and send all commands
in this file to the server, and executes any local commands.

You can load a file that you saved with the /save command.

Please note that recursive use of the /load command is not allowed.
So /load in a preset file will be ignored, and a warning will appear.

The status report has been improved, I removed (commented out) things that are
a bit technical (like the Cpia registers), and now auto white and auto
exposere, gain_ceiling etc.. should be correctly reported.

Also I changed syntax from gainceiling to gain_ceiling, as this is more
consistent with the other commands.

Since mcam.c was getting a bit big, I have moved some stuff to other files.

Please note that mcam does not use the ~/.mcamrc file in client mode, as the
server is already set.

To start a client with a preset file:
mcam -c -w PASSWORD -u filename
mcam will then load p.filename in the frames directory (could be your settings
saved with /save filename), and send the configuration to the server (if
password enabled it must match), and execute any local commands in filename.

version-1.1:
Program would go in loop if file in command line option -u was not found.
Fixed.

version-1.2:
Added date and time display in the picture:
>This only works with compression off<

There are TWO clocks.
One for the server, and one for the client.
These can be controlled independently.

In stand alone mode, the client clock is used.
Please monte that activaing the server clock  when coding (jpeg or mpeg) is on.
reduces the readability of the characters in the time date.

So if you are using mcam for securety, and really need a clear time / date readout,
use the client (local) clock.

If used stand alone, from the menu the following options are new:
'T' enbles or disables the data-time display.
't' submenu, you can select where you want the time to appear,
    top left, top middle, top right, bottom left, bottom middle, bottom right.
'u' toggles display format between local and UTC (= GMT).
If the display size is changed, with menu option 'P' or 'p', the time will
still be printed in the correct position.
For a small display, the format is slightly different, so it fits on screen.

The corresponding entries in ~/.mcamrc are:
show_time yes
	(or no)
clock_position top_right
	(or top_middle, top_left, bottom_right, bottom_middle, bottom_left)
time utc
	(or local)
For the moment characters appear white on a black background.

The commands in client mode to control the client side clock are:
/local clock on (or off)
/local time utc (or local)
/local clock_position top_left
 (or top_middle, top_right, bottom_left, bottom_middle, bottom_right)

To control the clock in the server use the '/camera' prefix:
/camera clock on (or off) etc..


Adding a text to the server display:
You can add a text to the server image (on the server side) from the client.
If you type:
/camera text screen
then all text typed at the console in the client will appear top left
(position 0,0) in the image from the server.
All connected clients can see this, and it appears in any thing saved to disk.
/camera text console
directs the text you write to the server console ONLY.
Of cause you need access permission for the server to do this.
The text stays on screen.
To clear the screen:
/camera text screen
just hit enter
and possible /camera text console
You can change the position where the text is printed:
/camera text_position 200 300
where 200 and 300 are the x and y position in pixels.
What not fits on the screen is ignored.
Also the color of the text can be altered, both the foreground and background:
/camera text_color 255 255 0 0 0 255
Gives yellow characters on a blue background.

If you do something like /camera 255 255 0 255 255 0, then you get a simple yellow
bar that perhaps could be used to mask out something.
So the sequence is: foreground red, fg green, fg blue, bg red, bg green, bg blue.
Values must be between o and 255.


Please note that ~/.mcamrc is read by the server on startup, or by a stand-
alone mcam, but NOT by the client.
So it basically sets the server defaults.
You can edit ~/.mcamrc, but better is to start mcam, use the menu to set
the defaults, then exit mcam, and start mcam again as server.

version-1.3:
Bugfixes.
To many files open fixed.

version-1.3.1:
Bug fix background color text.

version-1.3.2:
Faster code in text routine.

version-1.3.3:
Default frame_format for save now .ppm
This version can be compiled with or without X.
I have included 2 scripts:
make_x
make_no_x

The first builds and installs a normal X version (mcam).
The second a version without X windows, so you have no display (mcam_no_x).
Every thing else is the same, but display related functions do not work.
Files are still saved in .ppm (and if you have it installed mpeg and jpeg)
format.
This is useful if you want to run a server on a machine without X, or
send .ppm files with handshake from such a machine to a web server.

version-1.3.4:
Modified make files and scripts.
To the start server without x running in the background (if your port is 278,
else use 378):
nice -n 19 mcam_no_x -s -l 278 1> /dev/null 2 > /dev/null &

To start a client with display (where ... is your password for the server,
anything if no password required):
mcam -c -w ...


Character conventions:
The charatcter set used comes from my teletext (videotex or Ceefax) program
xkrs.
In this set the following differs from normal ASCII:
Code 91 A umlaut, was [ in ASCII
Code 92 O umlaut, was \ in ASCII
Code 93 U umlaut, was ] in ASCCI
Code 96 degrees symbol, was 'in ASCII
Code 123 a umlaut, was { in ASCII
Code 124 o umlaut, was | in ASCII
Code 125 u umlaut, was } in ASCII
Code 126 beta, was ~ in ASCII
Code 127 blokje upper sepa, was DEL
Fixed a bug that would cause the wrong color in the server every now
and then.
Wrote my own parser for the ppm format, as fscanf seems to think that
control M after \n needs to be swallowed.

                         -----------------
Version-1.3.5:
Now a character set with normal characters, and one with umlauts can be
selected:
In the client:
/camera characters normal
/camera characters umlaut

In the stand alone mcam, menu options 'K' and 'k'.
The default is no umlauts.
Set the default you want with the menu, this sets /root/.mcamrc, the server
reads this at startup.

(1.3.5.1 is the same as 1.3.5)
Sometimes I have to create a new version number if an upload to sunsite
fails.

Version-1.3.5.2:
Bugfix in /save
/characters was printed, where /camera characters should have been printed.

Version-1.3.5.3:
Bugfix in effects.dat, wrote != ipo = in detect_change.
errno.h added to some more .c files, so it will compile on the latest Suse.
prototype file added.

Version-1.3.5.4:
Apertur correction can now be set from the client.
This affects the sharpness and noise.
Try for example:
/camera apcor 1 5  1 5  1 5  1 5

To reset to factory recommended default:
/camera apcor_default

Version-1.4:
Huge modifications to structure of header in internet connection,
so more data can be returned by the server (server status).
It is done in such a way that older mcams should be compatible.

Apertur correction settings are now saved in ~/.mcamrc
The true aperture setting are returned by the server on /status command.
The server version is returned and displayed by /status.

Bugfixes that should now give sensible values in the menu for gain, and
exposure, if not initialized.
Menu options 'W' (set apertur submenu), and 'w' set apertur default added.
Setting from the menu with 'W' will create an entry in ~/.mcamrc.
mcam server will read this at start up.


Version-1.4.1:
Added the /local colordepth  (in bits per pixel) command in the client.
/status also shows the colordepth reported by X and the colordepth selected
by the user.
I noticed that on my system sometimes X reports 32 bpp, when the XF86Config
only has an entry for 24 bpp, but creating an entry for 32 bpp then results
in an error report (Xfree-4).
So it is worth experimenting with different color depth settings.


Version-1.4.2:
Added the -r command line option. so you can set a different location for
the .mcamrc file.
The default is the home directory.
This allows one to specify a different .mcamrc if using more then one
camera on the same PC.
The entries for for example option 'd' frame_dir from the menu and all
other settings can then be kept different.
mcam -r /root/mymcamdir will for example use a .mcamrc in /root/mymcamdir.
Use ls -a in that directory to see the hidden file,


Version-1.4.3:
Bugfix:
No longer using temp file in /tmp, but doing temp processing in frame dir,
to avoid problems with multiple camera's on one PC.

NOTE:
If using mpeg coding, you must edit the files big.par and small.par
so that these read the correct location of the file, for example if
you use /root/frames/ then the first lines must read:

MPEG-2 Verification Sequence
/root/frames/mcam-ppm    /* name of source files */

The older mcams used to use /tmp, but now sice you can use more then one
mcam on a PC, this would result in conflicting files (same filename).
big.par and small.par MUST be in your frames directories(s).


Version-1.5:
Wavelet coding / decoding now supported.
This uses the 'epic' wavelet codec from Prof. Eero P. Simoncelli from
the GRASP Laboratory in Philadelphia.
epic is available for non commercial use only.
You can download epic from:
http://www.cis.upenn.edu/~eero/epic.html

Note wavelet coding cannot be used in the compressed mode (no real
advantage anyways).

Some rewrites have been done, file wavelet.c has been added.
Please note that the epic software from Prof. Simoncelli is free for 
non commercial use ONLY, and is NOT GPL.

mcam creates files for Y, U, and V, uses epic 3 times to make wavelet code,
transmits that to the client, then creates files again to use unepic
to make a normal mcam (Vision) format.
You will see these files in your frame dir:

The files the server makes that epic uses:
mcam.y.pgm (luminance)
mcam.u.pgm (U color difference)
mcam.v.pgm (V color difference)

The files epic makes from these in the server:
mcam.y.wavelet
mcam.u.wavelet
mcam.v.wavelet

The files mcam client makes upon reception to use with unepic:
(should be identical to mcam.y.pgm mcam.u.pgm mcam.v.pgm in the server)
mcam.y.b.wavelet 
mcam.u.b.wavelet
mcam.v.b.wavelet

The files unepic makes from these in the client:
(these are not the same as mcam.y.pgm, cause wavelet compression is not loss
less)
mcam.y.b.pgm 
mcam.u.b.pgm
mcam.v.b.pgm

mcam client then reads these files and adds these together to make a normal
picture.

It is a bit complicated, but epic can only process BW pics, so to get color,
Y, U, and V are processed seperately.
You can use xv, or an other viewer, on the.pgm files to see what it looks
like, but u and v are of cause just the color difference signals..

The speed penalty of using all these files is very small compared to the
coding / decoding time of epic / unepic, because Linux caches it all.
(I have a grab +coding + display time of 1 second on a K6-2 450)

The advantage of using these files is that no changes need to be made to
epic and unepic.
Also now it becomes easier to write supporting code for other wavelet codecs,
many seem to only implement BW.

There are many different wavelet codecs on the net.

The advantage here of wavelets over say jpeg or mpeg, is that you do not get
those little square blocks in the screen at high compression rates.

Even at a coding_quality setting of 5 (%) the compression is about 15 times,
and the picture looks acceptable.

Other wavelet coders may or may not give better results and or compression.


Version-1.5.1:
Some modifications to CheckForCPIA() so it also works with the older
CPIA_100 chip version.
Goto low power in the menu (option 4) is disabled, as some routines need
high power mode to work.


Verison-1.6
/camera sensor_fps added.
This sets the frames per second for the sensor, and, if low, increases the
exposure time.
The result is that by low speeds the sensitivity is MUCH better, so low
light performance increases.
The default is the lowest speed (in fact 3.125 frames / second), that would
allow for an exposre of some 200ms.
Menu option 'z' has been added to alter this, but changing the default will
probably be not necesary.


Version-1.6.1
Some suggestions from "N.W. de Jong" <n.d.j@wolmail.nl> are incorporated.
To make it possible to use a cooled mcam, (-10 degrees centigrade),
the sensor divisor can be now set to 1 / 16.
This causes the top of the picture to have an exposure time of 
(8*8)/25 = 2,56 s, while at the botton the exposure time is still 8/25=0.32
Some new options in mcam (not the client server) have been added:
'0' grabs single frame,
'N' set sensor time
'n' set normal (2) or / 16 divider

The procedure to get a frame with a cooled camera is:
Start mcam and select from the menu:
a                       (auto exposure off)
R 255 511 3             (man exposure fine, course, and gain)
N 0 3                   (set fps and divider)
0                       (grab single frame)

The top picture should now be lighter (more sensitive) then the bottom.
Try this with a cooled camera.


Version 1.6.2:
Fixed gcc 3.3.3 compile errors.
Added mjpeg tools yuv output, so you can encode and record for example to DivX
with transcode:
Edit ~.mcamrc so it has the lines:
save_frames_format yuv
save_frames on
save_frames_start_frame 0
save_frames_frame_delay 0
coding off
frame_dir /huge/frames (or where you store the frames) 
size big

Save camera output as a DivX movie:
#start server first like this:
nice -n 15 mcam -s >/dev/null &

#then start the (remote)client
nice -n 19 mcam -c -w e | \
transcode -f 1 -i /dev/fd/0 -g 352x288 -x yuv4mpeg,null -y divx4 -z -o camera1.avi

#  Issue these commands in the client:
#  /camera clock on
#  /local frame_format yuv
## optionally
## /local motion_detection on
#  /local recording on

You can view camera1.avi with xine or mplayer.

If you do not have transcode installed, you can also use mencoder:
nice -n 19 mcam -c -w e | mencoder - -o camera1.avi -oac copy -ovc lavc

or ffmpeg:
nice -n 19 mcam -c -w e | \
ffmpeg -f yuv4mpegpipe -i - -f avi -vcodec mpeg4 -b 800 -g 300 -bf 2 -y camera1.avi 

You can also start mcam like this:
mcam | transcode -f 1 -i /dev/fd/0 -g 352x288 -x yuv4mpeg,null -y divx4 -z -o mcam.avi
Select option 'H', enter yuv.
Select option '9'
Now it records in DivX4 to mcam.avi
Press ENTER to stop, this takes you back into the menu.
Press ESCAPE key to exit mcam.


Version 1.6.3:
Motion detection would always show motion if compiled on some systems.

Declared arrays static, works now.

Note to contributers:

				*          *		
     All source files should be viewed and edited with tabs set to 4.
				*          *

PROBLEMS:
Compilation:
Make sure you have the kernel header files, and C compiler and
libs installed.
If you use X, also the X headerfiles must be installed.

Folded picture:
If you see a picture that appears 'folded' like the same scene repeated
more then once horizontally, and with horizontal lines, chances are
your colordepth is not correct.
Sometimes X reports the wrong colordepth (on some X servers).
You can start the X server with a specific colordepth by typing:
startx -- -bpp 16
The dashes are important.
Valid colordepth for mcam are 16, 24, and 32.
If you are sure that for example you always use 32, then you could
try to look for in file x11.c:
//UNCOMMENT ONE OF THESE LINES IF YOU WANT FIXED COLOR DEPTH.
//display_bits = 16;
//display_bits = 24;
//display_bits = 32;

Remove the '//, so the line looks:
display_bits = 32;

Of cause you can use 16, or 24 if you want.
Then recompile.

Conversion error:
If you get some 'conversion error' make sure you are not using the default
8 bit mode for x, try the things suggested above under folded picture.


Parport:
If you get startup errors, and mcam does not report the device id,
try if you can set the parallel port mode in BIOS setup to EPP, not ECP, or
perhaps some other mode.

BUGS:
The names of the menu options will one day have to match the command line
flags, do not hold your breath.

I have been over this file several times, but with any new version (read day)
everything changes.
Need a manual :)

Anyways, with a small picture, and a 28k modem upload, you will get
a new frame every 2 seconds or so, with one client.
Not at all bad, switching in compression ('E' in the menu) further
increases the speed, but leaves artifacts.
Enabling mpeg loses detail, gives picture artifacts, but increases speed
over the net by an incredible amount (40 to 100 x).
Or use jpeg, it is also very good, and then you do not need the Berkely codec.

But the big picture is much nicer, and even if you see a frame of your
loved one once every 60 seconds or so, it is still worth it:)

This program is released under the GPL.
email: panteltje@yahoo.com


